
/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#undef FILENAME
#define FILENAME "open_read_close.c"
#include "initng.h"

#define _GNU_SOURCE
#include <stdio.h>
#include <alloca.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>

#include "open_read_close.h"

int open_read_close(char *filename, char **buffert)
{
    int conf_file;              /* File descriptor for configfile       */
    int filesize;               /* Remember filesize here               */

    conf_file = open(filename, O_RDONLY);       /* Open configfile. */
    if (conf_file == -1)
    {
#ifdef DEBUG
        printf(" ** FAIL " FILENAME " open_read_close(%s) CANT OPEN FILE!\n",
               filename);
#endif
        *buffert = '\0';
        return (FAIL);
    }
    filesize = lseek(conf_file, 0, SEEK_END);   /* Get filesize.    */

    /* Check so that filesize is not to big */
    if (filesize >= MAX_FILESIZE)
    {
        printf("\n\n ** FAIL " FILENAME
               " initng_parser_open_read_close(%s) Config file to large\n",
               filename);
        printf
            (" ** FAIL Change source to be able to allocate bigger files\n");
        printf(" ** FAIL max size is %i, your is %i and %i to big.\n\n",
               MAX_FILESIZE, filesize, (filesize - MAX_FILESIZE));
        *buffert = '\0';
        return (FAIL);
    }
    lseek(conf_file, 0, SEEK_SET);      /* Go back to start. */

    *buffert = (char *) calloc(1, filesize + 1);        /* Allocate a file buffert */

    read(conf_file, *buffert, filesize);        /* Read whole file */
    (*buffert)[filesize] = '\0';        /* Null terminate last char of filebuf the EOF */
    if (close(conf_file) == 0)  /* Close file */
        return (TRUE);
    free(*buffert);
    *buffert = '\0';
    return (FAIL);
}
